"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var SqLiteResolverAux_1 = require("./util/SqLiteResolverAux");
function SqLiteResolver() {
    var aux = new SqLiteResolverAux_1.SqLiteResolverAux();
    return function Resolver(target, propertyKey, descriptor) {
        var originalValue = descriptor.value;
        descriptor.value = function () {
            var resolved = originalValue.apply(this, arguments);
            if (resolved instanceof rxjs_1.Observable) {
                resolved = aux.resolveFromObservable(resolved);
            }
            else if (resolved.then) {
                resolved = aux.resolveFromPromise(resolved);
            }
            else {
                throw new Error('This decorator only support working with Observables or Promises');
            }
            return resolved;
        };
        return descriptor;
    };
}
exports.SqLiteResolver = SqLiteResolver;
